import java.io.*;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;
import java.text.*;
import java.util.*;

import org.apache.log4j.spi.LoggingEvent;
import org.productivity.java.syslog4j.impl.log4j.Syslog4jAppender;
import org.apache.log4j.Layout;

public class SyslogTCPAppender extends Syslog4jAppender
{
	
	private static final long serialVersionUID = 1L;
	Socket MyClient;
	PrintStream output;
	DataOutputStream os = null;
	String Host;
	Layout myLayout;
	int Port;
	String strMessage;
	String strFacility;
	int intLevel;
	int intPriority;

	  /** @see org.apache.log4j.FileAppender#activateOptions() */
	  @Override
	  public void activateOptions()
	  {
	    super.activateOptions();
	    Host = super.getSyslogHost();
	    Port = Integer.parseInt(super.getPort());
	    strFacility = super.getFacility();
	    
	 }
	  

	  /** @see org.apache.log4j.WriterAppender#subAppend(LoggingEvent) */
	  @Override
	 public void doAppend( LoggingEvent event )
	
	  {
		  intLevel = event.getLevel().getSyslogEquivalent();
		  calc_priority();
		  		  
		  try
		  {	
			  String localHost = InetAddress.getLocalHost().getHostName();
			  String prgName = event.getLocationInformation().getClassName();
			  String strTrace = super.layout.format(event);
			  String search = "\n";
			  String	 msg = strTrace.replaceAll(search, " "); 			  
			  Date dt = new Date();
			  SimpleDateFormat df = new SimpleDateFormat( "yyyy-MM-dd'T'HH:mm:ss.S'Z'" );
			  df.setTimeZone(TimeZone.getTimeZone("UTC"));
			  String strDate = df.format( dt );
			  strMessage = "<" + intPriority + ">1 " + strDate + " " + localHost + " " + prgName + " - - "  +  msg + "\n";
			  MyClient = new Socket(Host, Port);
		      output = new PrintStream(MyClient.getOutputStream());
		      os = new DataOutputStream(MyClient.getOutputStream());
		      os.writeBytes(strMessage);
		      output.close();
		      os.close();
		      MyClient.close();  
	    	}
		  catch (UnknownHostException ex) 
	    	{
	    		// Fehler bei Verbindungsaufbau
	    		System.out.println("UnknownHostException");
	    		System.out.println(ex);
	    	}  
		  
	    	catch (IOException ex) 
	    	{
	    		// Fehler bei Verbindungsaufbau
	    		System.out.println("IOException");
	    		System.out.println(ex);
	    	}  
		  
	    
	  }
	  
	  public void calc_priority()
	  {
		  String [] aFacility = {"KERN", "USER", "MAIL", "DAEMON", "AUTH", "SYSLOG", "LPR", "NEWS", "UUCP", "CRON",
		  	"AUTHPRIV", "FTP", "LOCAL0", "LOCAL1", "LOCAL2", "LOCAL3", "LOCAL4", "LOCAL5", "LOCAL6", "LOCAL7"};
		  int [] intFac = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 16, 17, 18, 19, 20, 21, 22, 23 };
		  int ind2 = 1;
		  String strFac = strFacility.toUpperCase();
		  int ind;
		  for (ind = 0; ind < 20; ind++)	
		  {
			  
			  if (aFacility[ind].equals(strFac) )
			  {
				  ind2 = intFac[ind];
				  ind = 22;
			  }
		  }
		 
		  intPriority = ind2 * 8 + intLevel;
	  }
	    
	
	}

